/*

*/
#include <iostream>
//#include <cstring>
using namespace std;

int main()
{
   // s1 and s3 are equivalent strings, and s2 in NOT a string
   char s1[] = "hello";
   char s2[] = {'h', 'e', 'l', 'l', 'o'};
   char s3[] = {'h', 'e', 'l', 'l', 'o', '\0'};

   cout << s1 << endl << s3 << endl << s2 << endl;

   char my_string[20];         // not yet a string
   cout << my_string << endl;  // not a safe thing to do
   my_string[19] = '\0';       // now it is a string (it has been terminated)
   cout << my_string << endl;  // but its contents are random garbage

   char your_string[30] = "A kind of long string.";  // a partially filled array
   cout << endl << your_string << endl;
   your_string[10] = '\0';       // this shortens the string (but not the array)
   cout << your_string << endl;

   // Let us concatenate the strings "hello" and " and goodbye"
   // together into a third string
   char s4[] = "hello";
   char s5[] = " and goodbye";
   char s6[30];    // s6 is not yet a string
   s6[0] = '\0';   // now s6 is a string of length 0
   strcat(s6, s4); // copies s4 into s6
   strcat(s6, s5); // copies s5 onto the end of s6
   cout << s6 << endl;

   // make my_string and your_string the same string
   strcpy(  my_string, s4);
   strcpy(your_string, s4);
   // the following line does not test for the right kind of equality
   cout << (my_string == your_string) << endl;      // prints out 0 (for false)
   // this is the proper way to test if strings are equal
   cout << strcmp(my_string, your_string) << endl;  // prints out 0 (for equal)

   // make a small change in my_string
   my_string[4] = 'z';
   cout << my_string << endl;

   // ring (or "beep") your bell 5 times
   for (int i = 0; i < 5; i++)
      cout << "ring" << '\a' << endl;

   // do it again, in a slightly different way
   char beep = 7;  // ASCII character 7, also known as BELL or CTRL G
   cout << "Do it again!" << endl;
   for (int i = 0; i < 5; i++)
      cout << "ring" << beep << endl;

   // print out all 255 ASCII characters
   cout << endl;    // blank line
   unsigned char c;
   for (c = 1; c <= 254; c++)
      cout <<  c;

   return 0;
}
