/*
   This program demonstrates an example of a library function,
   open() on a stream, that only works with C-strings.

   If you have the name of the file in a C++ string object, you
   need to call the c_str() method in the string class to convert
   the name from a string object to a C-string.
*/
#include <fstream>
#include <iostream>
#include <iomanip>
using namespace std;


void eat_spaces(istream& in_stream = cin) // can accept any input stream, defaults to cin
{
   char next_char;
   in_stream.get(next_char);
   while(next_char == ' ')
   {
      in_stream.get(next_char);
   }
   in_stream.putback(next_char);
}

int main()
{
   // prompt the user for the external file name of the input file
   cout << "Input file for the filter: ";
   string in_file;  // the name is stored in a string object
   cin >> in_file;

   // create an input file stream object
   ifstream in_stream;

   // associate the external file to the input file stream
   in_stream.open( in_file.c_str() );   // open for input
   if (in_stream.fail())
   {
      cerr << "Error opening input file: " << in_file << endl;
      exit(1);  // not a good idea
   }

   // remove all spaces from the input file
   char next_char;
   while( in_stream.get(next_char) )
      if (next_char == ' ')
         eat_spaces(in_stream);
      else
         cout.put(next_char);

   return 0;
}
